function [ sorted ] = bubblesort( unsorted )
%BUBBLESORT Ordina il vettore con l'algoritmo BubbleSort
% All'algoritmo viene passato il vettore non ordinato unsorted e, al
% termine, si ottiene il vettore ordinato sorted
% Ad esempio, lanciando  bubblesort([4 7 3 5 2])  dalla finestra dei
% comandi si otterr  ans = 2 3 4 5 7

% se il vettore  composto da un unico elemento o  vuoto, non  necessario
% effettuare alcun ordinamento e l'algoritmo termina
if length(unsorted)<2
    sorted=unsorted;
    return;
    
% in caso contrario, eseguo l'algoritmo visto a lezione
else
    % eseguo l'algoritmo tante volte quanti sono gli elementi nel vettore,
    % quanto  lungo il vettore considerato
    for l=1:length(unsorted)
    
        % ad ogni iterazione scorro l'intero vettore 
        for i=2:length(unsorted)
            % confronto le coppie di elementi adiacenti, scambiandoli se
            % non sono in ordine
            if (unsorted(i-1)>unsorted(i))
                
                % per scambiare i due elementi adiacenti copio il secondo
                % elemento considerato in una variabile temporanea swap;
                % successivamente copio il valore del primo elemento nella
                % seconda posizione ed infine salvo nella prima posizione
                % il valore presente nella variabile temporanea
                swap=unsorted(i);
                unsorted(i)=unsorted(i-1);
                unsorted(i-1)=swap;
            end
        end
    end
    
    sorted=unsorted;
    return;
end